unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, VKRep_TLB,
  StdCtrls, Db, DBTables;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Label1: TLabel;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    oDB: TTable;
    Button6: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
  private
    { Private declarations }
    oRep: TVKReport;
    stop: boolean;
    ii: Integer;
    s1, s2: double;
    som: Integer;
    procedure OnStartReport(Sender: TObject);
    procedure OnEndReport(Sender: TObject);
    procedure OnError(Sender: TObject; mError: OleVariant; nError: OleVariant; sError: OleVariant);
    procedure OnMoveTop(Sender: TObject);
    procedure OnMoveNext(Sender: TObject);
    procedure OnRequestByNum(Sender: TObject; SectionName: OleVariant; SectionNum: OleVariant; iP: OleVariant);
    procedure OnRequestByName(Sender: TObject; SectionName: OleVariant; SectionNum: OleVariant; sFieldName: OleVariant);
    procedure OnDataRequest(Sender: TObject; SectionName: OleVariant; SectionNum: OleVariant; sData: OleVariant; OutR: OleVariant; OutC: OleVariant; InR: OleVariant; InC: OleVariant);
    procedure OnSectionCheck(Sender: TObject; SectionName: OleVariant; SectionNum: OleVariant);
    procedure OnSectionBegin(Sender: TObject; SectionName: OleVariant; SectionNum: OleVariant);
    procedure OnSectionPrepare(Sender: TObject);
  public
    { Public declarations }
    constructor Create(aOwner: TComponent); override;
    destructor Destroy; override;
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

{ TForm1 }

constructor TForm1.Create(aOwner: TComponent);
begin
  inherited Create(aOwner);
  oRep := TVKReport.Create(self);
  oRep.Connect;
end;

destructor TForm1.Destroy;
begin
  oRep.Disconnect;
  oRep.Free;
  inherited Destroy;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  stop := false;
  oRep.TypeReport := ittrRTF_HTML;
  oRep.InputBlank := 'C:\components\Reports\VK Reports\DLL\Samples\Delphi 5\Automation Client\WordRep.rtf';
  oRep.OutputBlank := 'C:\components\Reports\VK Reports\DLL\Samples\Delphi 5\Automation Client\RepOut.rtf';
  oRep.OnReportError := OnError;
  oRep.OnStartReport := OnStartReport;
  oRep.OnEndReport := OnEndReport;
  oRep.OnMoveTop := OnMoveTop;
  oRep.OnMoveNext := OnMoveNext;
  oRep.OnRequestByNum := OnRequestByNum;
  oRep.OnRequestByName := OnRequestByName;
  oRep.OnSectionCheck := OnSectionCheck;
  oRep.OnSectionBegin := OnSectionBegin;
  oRep.OnSectionPrepare := OnSectionPrepare;
  oRep.ReportResume;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  stop := false;
  oRep.TypeReport := ittrRTF_HTML;
  oRep.InputBlank := 'WordRep.HTML';
  oRep.OutputBlank := 'RepOut.HTML';
  oRep.OnReportError := OnError;
  oRep.OnStartReport := OnStartReport;
  oRep.OnEndReport := OnEndReport;
  oRep.OnMoveTop := OnMoveTop;
  oRep.OnMoveNext := OnMoveNext;
  oRep.OnRequestByNum := OnRequestByNum;
  oRep.OnRequestByName := OnRequestByName;
  oRep.OnSectionCheck := OnSectionCheck;
  oRep.OnSectionBegin := OnSectionBegin;
  oRep.OnSectionPrepare := OnSectionPrepare;
  oRep.ReportResume;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  stop := false;
  oRep.TypeReport := ittrSYLK;
  oRep.InputBlank := 'SylkRep.slk';
  oRep.OutputBlank := 'SylkOut.slk';
  oRep.OnReportError := OnError;
  oRep.OnStartReport := OnStartReport;
  oRep.OnEndReport := OnEndReport;
  oRep.OnMoveTop := OnMoveTop;
  oRep.OnMoveNext := OnMoveNext;
  oRep.OnRequestByNum := OnRequestByNum;
  oRep.OnRequestByName := OnRequestByName;
  oRep.OnSectionCheck := OnSectionCheck;
  oRep.OnSectionBegin := OnSectionBegin;
  oRep.OnSectionPrepare := OnSectionPrepare;
  oRep.OnDataRequest := OnDataRequest;
  oRep.ReportResume;
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
  stop := false;
  oRep.TypeReport := ittrCOM_XLS;
  oRep.InputBlank := 'XRep.xls';
  oRep.InputSheet := 'EReport Input';
  oRep.OutputBlank := 'XOut.xls';
  oRep.OnReportError := OnError;
  oRep.OnStartReport := OnStartReport;
  oRep.OnEndReport := OnEndReport;
  oRep.OnMoveTop := OnMoveTop;
  oRep.OnMoveNext := OnMoveNext;
  oRep.OnRequestByNum := OnRequestByNum;
  oRep.OnRequestByName := OnRequestByName;
  oRep.OnSectionCheck := OnSectionCheck;
  oRep.OnSectionBegin := OnSectionBegin;
  oRep.OnSectionPrepare := OnSectionPrepare;
  oRep.OnDataRequest := OnDataRequest;
  oRep.ReportExecute;
end;

procedure TForm1.OnStartReport(Sender: TObject);
begin
  ShowMessage('Report is starting - ' + oRep.InputBlank + ' !');
  s1 := 0;
  s2 := 0;
end;

procedure TForm1.OnEndReport(Sender: TObject);
begin
  ShowMessage('Report is ending - ' + oRep.OutputBlank + ' !');
end;

procedure TForm1.OnError(Sender: TObject; mError, nError,
  sError: OleVariant);
begin
  ShowMessage(sError);
end;

procedure TForm1.OnMoveNext(Sender: TObject);
begin
  Inc(ii);
  oDB.Next;
  Application.ProcessMessages;
  Label1.Caption := IntToStr(ii) + ' / ' + IntToStr(oDB.RecNo);
  oRep.RequestCheck(oDB.Eof or stop);
  //This feature is not supported in Automation Object - dad lock thread.
  //if (oDB.RecNo mod 10) = 0 then
  //  oRep.OutSectionByName('SOMTHING');
  //  //oRep.OutSectionByNum(som);
end;

procedure TForm1.OnMoveTop(Sender: TObject);
begin
  ii := 1;
  oDB.First;
  Label1.Caption := IntToStr(ii) + ' / ' + IntToStr(oDB.RecNo);
  oRep.RequestCheck(oDB.Eof);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  stop := true;
end;

procedure TForm1.OnRequestByNum(Sender: TObject; SectionName, SectionNum, iP: OleVariant);
var
  RetStr: String;
begin
  if SectionNum = snREPORT_HEADER then
  begin
    RetStr := '';
    case iP of
      1: RetStr := 'First parameter.';
      2: RetStr := 'Second parameter.';
    end;
    oRep.RequestAll(RetStr, true);
  end;
  if SectionNum = snGROUP_HEADER then
  begin
    RetStr := Trim(oDB.Fields[4].AsString);  //#STATE
    oRep.RequestAll(RetStr, true);
  end;
  if SectionNum = snBODY then
  begin
    RetStr := '';
    case iP of
      1: RetStr := oDB.FieldByName('First').AsString + ' ' + oDB.FieldByName('Last').AsString;
      //2:
      3: RetStr := oDB.FieldByName('City').AsString;
      //4:
      5: RetStr := oDB.FieldByName('ZIP').AsString;
      6: RetStr := oDB.FieldByName('Age').AsString;
      7: RetStr := Format('%9.2f', [oDB.FieldByName('Salary').AsFloat]);
    end;
    oRep.RequestAll(RetStr, true);
  end;
  if SectionNum = snGROUP_FOOTER then
  begin
    if iP = 1 then RetStr := Trim(oDB.Fields[4].AsString);
    if iP = 2 then
    begin
      RetStr := Format('%10.3f', [s1]);
      s1 := 0;
    end;
    oRep.RequestAll(RetStr, true);
  end;
  if SectionNum = snREPORT_FOOTER then
  begin
    RetStr := Format('%10.3f', [s2]);
    oRep.RequestAll(RetStr, true);
  end;
end;

procedure TForm1.OnRequestByName(Sender: TObject; SectionName, SectionNum, sFieldName: OleVariant);
var
  RetStr: String;
begin
  if SectionNum = som then
  begin
    RetStr := Format('%d', [oDB.RecNo]);
    oRep.RequestAll(RetStr, true);
  end;
  if SectionNum = snFILE_HEADER then
  begin
    ShowMessage('Colontitul Text: ' + sFieldName);
    RetStr := 'Hello from colontitul!';
    oRep.RequestAll(RetStr, true);
  end;
  if SectionNum = snBODY then
  begin
    RetStr := oDB.FieldByName(sFieldName).AsString;
    oRep.RequestAll(RetStr, true);
  end;
end;

procedure TForm1.OnSectionCheck(Sender: TObject; SectionName, SectionNum: OleVariant);
var
  OldGroup: String;
  bCheck: boolean;
begin
  if SectionNum = snGROUP_HEADER then
  begin
    bCheck := false;
    oDB.Prior;
    if not oDB.Bof then
    begin
        OldGroup :=  Trim(oDB.Fields[4].AsString);  //#STATE
        oDB.Next;
    end
    else
    begin
        OldGroup := 'hhhhhhhhhhhhhhhhhhhhhhh';
    end;
    if OldGroup <> Trim(oDB.Fields[4].AsString) then bCheck := true;
    oRep.RequestCheck(bCheck);
  end;
  if SectionNum = snGROUP_FOOTER then
  begin
    bCheck := false;
    oDB.Next;
    if not oDB.Eof then
    begin
        OldGroup := Trim(oDB.Fields[4].AsString);  //#STATE
        oDB.Prior;
    end else begin
        OldGroup := 'chfdhhtryrye';
    end;
    if OldGroup <> Trim(oDB.Fields[4].AsString) then bCheck := true;
    oRep.RequestCheck(bCheck);
  end;
end;

procedure TForm1.OnSectionBegin(Sender: TObject; SectionName,
  SectionNum: OleVariant);
begin
  if SectionNum = snBODY then
  begin
    s1 := s1 + oDB.Fields[9].AsFloat;  //#SALARY
    s2 := s2 + oDB.Fields[9].AsFloat;  //#SALARY
  end;
end;

procedure TForm1.OnSectionPrepare(Sender: TObject);
var
  o: OleVariant;
begin
  o := -1;
  oRep.PrepareSection('SOMTHING', o);
  som := o;
end;

procedure TForm1.OnDataRequest(Sender: TObject; SectionName, SectionNum,
  sData, OutR, OutC, InR, InC: OleVariant);
var
  RetStr: Variant;
begin
  if SectionNum = snGROUP_HEADER then
  begin
    if sData = '1'#0 then
    begin
      oRep.RequestAll(oDB.Fields[4].AsVariant, true);
    end;
  end;
  if SectionNum = snBODY then
  begin
    if sData = '1'#0 then
    begin
      RetStr := oDB.FieldByName('First').AsString + ' ' + oDB.FieldByName('Last').AsString;
      oRep.RequestAll(RetStr, true);
    end;
    if sData = '3'#0 then
    begin
      RetStr := oDB.FieldByName('City').AsVariant;
      oRep.RequestAll(RetStr, true);
    end;
    if sData = '5'#0 then
    begin
      RetStr := oDB.FieldByName('ZIP').AsVariant;
      oRep.RequestAll(RetStr, true);
    end;
    if sData = '6'#0 then
    begin
      RetStr := oDB.FieldByName('Age').AsVariant;
      oRep.RequestAll(RetStr, true);
    end;
    if sData = '7'#0 then
    begin
      //RetStr := Format('%9.2f', [oDB.FieldByName('Salary').AsFloat]);
      oRep.RequestAll(oDB.FieldByName('Salary').AsFloat, true);
    end;
  end;
  if SectionNum = snGROUP_FOOTER then
  begin
    if sData = '1'#0 then
    begin
      RetStr := Trim(oDB.Fields[4].AsString);
      oRep.RequestAll(RetStr, true);
    end;
    if sData = '2'#0 then
    begin
      //RetStr := Format('%9.2f', [s1]);
      oRep.RequestAll(s1, true);
      s1 := 0;
    end;
  end;
  if SectionNum = snREPORT_FOOTER then
  begin
    if sData = '1'#0 then
    begin
      //RetStr := Format('%9.2f', [s2]);
      oRep.RequestAll(s2, true);
    end;
  end;
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
  stop := false;
  oRep.TypeReport := ittrXLS4;
  oRep.InputBlank := 'XLS4Rep.xls';
  oRep.OutputBlank := 'XLS4Out.xls';
  oRep.OnReportError := OnError;
  oRep.OnStartReport := OnStartReport;
  oRep.OnEndReport := OnEndReport;
  oRep.OnMoveTop := OnMoveTop;
  oRep.OnMoveNext := OnMoveNext;
  oRep.OnRequestByNum := OnRequestByNum;
  oRep.OnRequestByName := OnRequestByName;
  oRep.OnSectionCheck := OnSectionCheck;
  oRep.OnSectionBegin := OnSectionBegin;
  oRep.OnSectionPrepare := OnSectionPrepare;
  oRep.OnDataRequest := OnDataRequest;
  oRep.ReportExecute;
end;

end.
